'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _importModule = require('./importModule');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (render, options, asyncRenderer) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(_class, _Component);

    function _class() {
      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this));

      _this.isComponentMounted = false;

      _this.state = { nextProps: {}, WrappedComponent: null };
      return _this;
    }

    _createClass(_class, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.isComponentMounted = true;
        this.resolveRenderMethod();
      }
    }, {
      key: 'resolveRenderMethod',
      value: function resolveRenderMethod() {
        var _this2 = this;

        var WrappedComponent = void 0;
        var idx = void 0;
        if (asyncRenderer) {
          idx = asyncRenderer.getAsyncRenderIdx();
        }

        if (asyncRenderer && asyncRenderer.renderPass) {
          WrappedComponent = asyncRenderer.getAsyncRenderResult(idx);
        }

        if (!WrappedComponent) {
          (0, _importModule.setAsyncRenderer)(asyncRenderer);
          WrappedComponent = render(this.props.matchProps, _extends({}, this.state.nextProps));
        }

        if (WrappedComponent.then) {
          if (asyncRenderer) {
            asyncRenderer.awaitForAsyncRender++;
          }

          WrappedComponent.then(function (Component) {
            if (asyncRenderer) {
              asyncRenderer.storeAsyncRenderResult(idx, Component);
              asyncRenderer.awaitForAsyncRender--;
              asyncRenderer.handleModuleLoaded();
            } else {
              if (_this2.isComponentMounted) _this2.setState({ WrappedComponent: Component });
            }
          });
        } else {
          this.setState({ WrappedComponent: WrappedComponent });
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.isComponentMounted = false;
      }
    }, {
      key: 'render',
      value: function render() {
        if ((0, _react.isValidElement)(this.state.WrappedComponent)) {
          return this.state.WrappedComponent;
        } else if (typeof this.state.WrappedComponent === 'function') {
          var WrappedComponent = this.state.WrappedComponent;

          return _react2.default.createElement(WrappedComponent, null);
        }
        return null;
      }
    }]);

    return _class;
  }(_react.Component), _class.propTypes = {
    matchProps: _react.PropTypes.object
  }, _temp;
};